// ߂̈⌾ (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*5*80];		// 傫K

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

bool fsave(char *_fname, unsigned char *_pt, int _size)
{
	fp = fopen(_fname,"wb");
	printf ("cutting ... %s\n",_fname);
	fwrite(_pt, 1, _size, fp);
	fclose(fp);
	return true;
}

unsigned char ans(unsigned char *_pt)
{
	unsigned char s=*_pt;
	for (int i=0;i<0x400;i++)
	{
		s &= *(_pt++);
	}
	return s;
}

struct fpos
{
	int trk;
	int sec;
	int ofs;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[11];
	int i,d;

	// Disk B
	struct fpos md1[] =
	{
		{ 0x3c, 0x01, 0x0041, 0x0d06 },	// 
		{ 0x3c, 0x04, 0x0147, 0x06e0 },	// 
		{ 0x3d, 0x01, 0x0027, 0x0c98 },	// 
		{ 0x3d, 0x04, 0x00bf, 0x0826 },	// 
		{ 0x3e, 0x01, 0x00e5, 0x094a },	// 
		{ 0x3e, 0x03, 0x022f, 0x07ce },	// 
		{ 0x3e, 0x05, 0x01fd, 0x0bf2 },	// 
		{ 0x3f, 0x03, 0x01ef, 0x068c },	// ??
		{ 0x00, 0x00, 0x0000, 0x0000 },	// 
	};

	// Disk D
	struct fpos md2[] =
	{
		{ 0x43, 0x05, 0x00fc, 0x0906 },	// 
		{ 0x43, 0x05, 0x0a02, 0x07f8 },	// 
		{ 0x43, 0x05, 0x11fa, 0x0ca2 },	// 
		{ 0x43, 0x05, 0x1e9c, 0x07a8 },	// 
		{ 0x43, 0x05, 0x2644, 0x067a },	// 
		{ 0x43, 0x05, 0x2cbe, 0x09f0 },	// 
		{ 0x00, 0x00, 0x0000, 0x0000 },	// 
	};

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x05);
		// fBXN
		if (disk.ReadDATA1(0x27, 0x13, 0x01, 0x10, 0x01, buff, 0x100))
		{
			printf("Disk A F܂.\n");
			disk.SetRecordRange(0x01,0x10);
			fcut("BIOS", 0x00, 0x00, 0x00, 0x02, 0x01, 0x0000, 0x0400);
//			disk.SetRecordRange(0x01,0x05);
//			fcut("DEMO",  0x28, 0x14, 0x00, 0x01, 0x03, 0x0000, 0x2300);
//			fcut("MUS00", 0x28, 0x14, 0x00, 0x01, 0x03, 0x0bd5, 0x0d06);
			continue;
		}
		if (!disk.ReadDATA1(0x01, 0x00, 0x01, 0x01, 0x03, buff, 0x400)) continue;
		if (ans(buff)!=0xff)
		{
			printf("Disk B F܂.\n");
			fcut("PROG", 0x01, 0x00, 0x01, 0x01, 0x03, 0x0000, 0x6000);
//			fsave("MUS00", &buff[0x0eb6], 0xc98);
			// ȃf[^̐؂o
			for (i=0; md1[i].trk; i++)
			{
				sprintf(fname,"MUS%02d",i);
				fcut(fname, md1[i].trk, md1[i].trk>>1, md1[i].trk&1, md1[i].sec, 0x03, md1[i].ofs, md1[i].size);
			}
			continue;
		}
		if (!disk.ReadDATA1(0x09, 0x04, 0x01, 0x05, 0x03, buff, 0x400)) continue;
		if (ans(buff)==0xff)
		{
			printf("Disk D F܂.\n");
			// ȃf[^̐؂o
			for (i=0; md2[i].trk; i++)
			{
				sprintf(fname,"MUS%02d",i+8);
				fcut(fname, md2[i].trk, md2[i].trk>>1, md2[i].trk&1, md2[i].sec, 0x03, md2[i].ofs, md2[i].size);
			}
			continue;
		}
	}
	return 0;
}

